require 'tk'

# Window drawing section.

font_name = "arial 10"

root = TkRoot.new() { title "ADD BOX" }
root.geometry('+195+200')

boxes_frame = TkFrame.new(root).pack(:side=>:top, :fill=>:x)

first_box_frame = TkFrame.new(boxes_frame, :borderwidth=>3, :relief=>:ridge).pack(:anchor=>"n", :side=>:left, :padx=>10, :pady=>10)
first_label = TkLabel.new(first_box_frame, :text=>"First Box", :relief=>:sunken, :width=>9, :background=>"lightgrey", "font"=>font_name).pack(:fill=>:x)

first_text_frame = TkFrame.new(first_box_frame).pack("side"=>"top")
first_box_bar_vert = TkScrollbar.new(first_text_frame).pack("side"=>"right", "fill"=>"y")
first_box_text = TkText.new(first_text_frame, "wrap"=>"none", "width"=>10, "height"=>4, "font"=>font_name).pack("side"=>"left")
first_box_text.yscrollbar(first_box_bar_vert)

clear_first_button = TkButton.new(first_box_frame, :text=>"Clear List", :background=>"lightgrey", :foreground=>"blue", "font"=>font_name).pack(:pady=>10)

last_box_frame = TkFrame.new(boxes_frame, :borderwidth=>3, :relief=>:ridge).pack("anchor"=>"n", "side"=>"left", "padx" =>20, "pady" =>10)
last_label = TkLabel.new(last_box_frame, :text=>"Last Box", :relief=>:sunken, :width=>9, :background=>"lightgrey", "font"=>font_name).pack(:fill=>:x)

last_text_frame = TkFrame.new(last_box_frame).pack("side"=>"top")
last_box_bar_vert = TkScrollbar.new(last_text_frame).pack("side"=>"right", "fill"=>"y")
last_box_text = TkText.new(last_text_frame, "wrap"=>"none", "width"=>10, "height"=>4, "font"=>font_name).pack("side"=>"left")
last_box_text.yscrollbar(last_box_bar_vert)

clear_last_button = TkButton.new(last_box_frame, :text=>"Clear List", :background=>"lightgrey", :foreground=>"blue", "font"=>font_name).pack(:pady=>10)

box_offsets_frame = TkFrame.new(boxes_frame, :borderwidth=>3, :relief=>:ridge).pack("anchor"=>"n", "side"=>"left", "padx"=>10, "pady"=>10)
offsets_label = TkLabel.new(box_offsets_frame, :text=>"Box Offsets", :relief=>:sunken, :width=>9, :background=>"lightgrey", "font"=>font_name).pack(:fill=>:x)

offsets_text_frame = TkFrame.new(box_offsets_frame).pack("side"=>"top")
offsets_bar_vert = TkScrollbar.new(offsets_text_frame).pack("side"=>"right", "fill"=>"y")
offsets_text = TkText.new(offsets_text_frame, "wrap"=>"none", "width"=>10, "height"=>4, "font"=>font_name).pack("side"=>"left")
offsets_text.yscrollbar(offsets_bar_vert)

clear_offsets_button = TkButton.new(box_offsets_frame, :text=>"Clear List", :background=>"lightgrey", :foreground=>"blue", "font"=>font_name).pack(:pady=>10)

format_frame = TkFrame.new(boxes_frame, :borderwidth=>3, :relief=>:ridge).pack("anchor"=>"n", "side"=>"left", :pady=>10, :padx=>20, :fill=>:x)

format_label = TkLabel.new(format_frame, :text=>"Format Strings", :relief=>:sunken, :background=>"lightgrey", "font"=>font_name).pack(:fill=>:x)
format_label.pack()

format_list = TkListbox.new(format_frame, "background"=>"white", "exportselection" => 0, "height"=>4, "font"=>font_name).pack("side"=>"left", :fill=>:x)

format_list.insert("end", "$CUR")
format_list.insert("end", "'%0.0f'")
format_list.insert("end", "'%0.2f'")
format_list.insert("end", "NONE")

#These set the default format_list selections at startup. The indices start at 0, which is the default - no need to activate it.
#~ format_list.activate(1)
#~ format_list.activate(2)

format_list.selection_set(0)	# Highlight first one.
#~ format_list.selection_set(1)
#~ format_list.selection_set(2)

button_frame = TkFrame.new(root).pack(:side=>:top, :fill=>:x, :padx=>10, :pady=>5)

add_button = TkButton.new(button_frame, :width=>12, :background=>"lightgrey", :text=>"Add Boxes", :foreground=>"blue", "font"=>font_name).pack(:side=>:left, :anchor=>:s)

print_button = TkButton.new(button_frame, :width=>12, :background=>"lightgrey", :text=>"Print ON", :foreground=>"blue", "font"=>font_name).pack(:side=>:left, :padx=>10, :anchor=>:s)

exit_button = TkButton.new(button_frame, :width=>12, :foreground=>"red", :text=>"Exit", :background=>"lightgrey", "font"=>font_name).pack(:side=>:left, :anchor=>:s)

clear_all_button = TkButton.new(button_frame, :width=>12, :text=>"Clear All", :foreground=>"blue", :background=>"lightgrey", "font"=>font_name).pack(:side=>:left, :anchor=>:s, :padx=>10)

dest_frame = TkFrame.new(button_frame, :borderwidth=>3, :relief=>:ridge).pack(:side=>:left)
dest_label = TkLabel.new(dest_frame, :text=>"Dest Box", :relief=>:sunken, :background=>"lightgrey", "font"=>font_name).pack(:fill=>:x, :anchor=>:s)

dest_text = TkVariable.new
dest_entry = TkEntry.new(dest_frame, :textvariable=>dest_text, "font"=>font_name, :width=>12).pack()

output_frame = TkFrame.new(root, :borderwidth=>3, :relief=>:ridge).pack(:side=>:top, :fill=>:x, :padx=>10)

output_label = TkLabel.new(output_frame, :text=>"Add Box Output Zone: ' Ctrl-/ ' selects all text.", :relief=>:sunken, :background=>"lightgrey", "font"=>font_name, :borderwidth=>3).pack(:side=>:top, :fill=>:x)
out_text_bar_vert = TkScrollbar.new(output_frame).pack(:side=>:right, :fill=>:y)
out_text = TkText.new(output_frame, :height=>12, "font"=>font_name).pack(:side=>:bottom, :fill=>:x, :expand=>true)
out_text.yscrollbar(out_text_bar_vert)

bottom_frame = TkFrame.new(root).pack(:side=>:top, :fill=>:x, :pady=>5)

# Action section.

clear_first_button.bind("Button-1") { first_box_text.delete("1.0", "end") }
clear_last_button.bind("Button-1") { last_box_text.delete("1.0", "end") }
clear_offsets_button.bind("Button-1") { offsets_text.delete("1.0", "end") }

clear_all_button.bind("Button-1") {

	first_box_text.delete("1.0", "end")
	last_box_text.delete("1.0", "end")
	offsets_text.delete("1.0", "end")
	dest_text.value = ''
}

add_button.bind("Button-1") {

	# Clear the output area.
	out_text.delete("1.0", "end")

	#
	# Make sure the arrays are the same size:
	#
	first_page_num_array = Array.new
	last_page_num_array = Array.new
	offsets_array = Array.new
	add_str = String.new
	format_str = String.new

	first_box_text.get("1.0", "end").scan(/(box)(\d+)(_)(\d+)/) {
		first_page_num_array.push([$2.to_i,$4.to_i])
	}

	last_box_text.get("1.0", "end").scan(/(box)(\d+)(_)(\d+)/) {
		last_page_num_array.push([$2.to_i,$4.to_i])
	}

	offsets_array = offsets_text.get("1.0", "end").scan(/\d+\n/)

	if ((first_page_num_array.length != last_page_num_array.length) or (first_page_num_array.length != offsets_array.length))
		out_text.insert("end", "ERROR - NEED THE SAME NUMBER OF 'First' AND 'Last' BOXES AND 'Box Offsets'\n")
	else

		#
		# Run thru the arrays (which are the same size) and process AS LONG AS first and last page numbers are the same and
		# the first box num is less than the last box num. ex: First Box - box1_10; Last Box - box1_20 are OK, but if Last Box
		# was equal to box2_13, this would be an error because the page nums are not the same. Or (same First Box value) a Last
		# Box value of box1_5 would be wrong because the box num in the Last Box is less than 10.
		#
		first_page_num_array.each_index { |x|

			if ((first_page_num_array[x][0] == last_page_num_array[x][0]) and (offsets_array[x].to_i > 0))

				page =  first_page_num_array[x][0].to_i
				num = first_page_num_array[x][1].to_i

				while (num <= last_page_num_array[x][1].to_i)
					add_str += "box#{page}_#{num}.to_f + "
					num += offsets_array[x].to_i
				end
			end
		}

		format_str = case format_list.index("active")
					when 0 then " $CUR % "
					when 1 then " '%0.0f' % "
					when 2 then " '%0.2f' % "
					when 3 then ""
				end

		add_str = "#{dest_text.to_s} = #{format_str}(#{add_str.chomp!(" + ")})\n"
		out_text.insert("end", add_str)

		if (print_button.cget("text") == "Print ON")
			out_text.insert("end", "print '#{dest_text.to_s}', #{dest_text.to_s}")
		end

	end

	# Set the focus to the output text window, and put the cursor at the first char on line one.
	out_text.focus
	out_text.mark_set('insert', '1.0')
}

print_button.bind("Button-1") {

	#
	# User can toggle the associated Print line "ON/OFF".
	#
	case print_button.cget("text")

		when "Print OFF" then print_button.configure("text", "Print ON")
		when "Print ON" then print_button.configure("text", "Print OFF")
	end
	}

exit_button.bind("Button-1") { exit(0) }

Tk.mainloop()
